summaryrefslogtreecommitdiff
path: root/tests/misc/dircolors
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/dircolors')
-rwxr-xr-xtests/misc/dircolors59
1 files changed, 59 insertions, 0 deletions
diff --git a/tests/misc/dircolors b/tests/misc/dircolors
new file mode 100755
index 000000000..e93d2fb7d
--- /dev/null
+++ b/tests/misc/dircolors
@@ -0,0 +1,59 @@
+#!/bin/sh
+# Simple dircolors tests.
+
+# Copyright (C) 1998, 2003, 2005-2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+me=`echo $0|sed 's,.*/,,'`
+exec $PERL -w -I$srcdir/.. -MCoreutils -M"CuTmpdir qw($me)" -- - <<\EOF
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+ (
+ ['a', '-b', {IN => {k => "exec\n"}},
+ {ERR => "dircolors: k:1: invalid line; missing second token\n"},
+ {EXIT => 1}],
+ ['quote', '-b', {IN => "exec 'echo Hello;:'\n"},
+ {OUT => "LS_COLORS='ex='\\''echo Hello;\\:'\\'':';\n"
+ . "export LS_COLORS\n"}],
+ ['other-wr', '-b', {IN => "owt 40;33\n"},
+ {OUT => "LS_COLORS='tw=40;33:';\nexport LS_COLORS\n"}],
+
+ # CAREFUL: always specify the -b option, unless explicitly testing
+ # for csh syntax output.
+ );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $prog = 'dircolors';
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF